#! /bin/sh
# TFTPD on the fly file generator (Icatis Extension)
# $Id: gen.sh,v 1.3 2005/07/29 09:20:45 pl Exp $ 
# (C) 2004-2005 ICATIS
#
# NB: - the output must go on stdout

EXITSTATUS=0

FILE="$1" 

# We need to get some extra information from a web server to generate the file
# The web server ($URL) gets $ETHER as input
URL='http://127.0.0.1/cm/engine/get_pxeconf.php?mac='

# $URL output set shell variables
eval `wget -q -O- "${URL}${FILE}" | grep "^[[:alnum:]_]\+="`

# If static bootmode type

if [ "$BOOTMODETYPE" = "RawPXEConfig" ] && \
	[ -n "$CONFIGFILE" ] && \
	[ -r "/PXEClient/pxelinux.cfg/$CONFIGFILE" ] ; then
	cat "/PXEClient/pxelinux.cfg/$CONFIGFILE"
	exit $EXITSTATUS
fi

# If computemode bootmode type...

if [ "$BOOTMODETYPE" = "ComputeMode" ] && \
	[ -n "$KERNEL" ] && [ -r "/PXEClient/$KERNEL" ] && \
	[ -n "$INITRD" ] && [ -r "/PXEClient/$INITRD" ] && \
	[ -n "$CMDLINE" ]; then
	cat <<EOF
default computemode
implicit 0
allowoptions 0
timeout 0
label computemode
 kernel $KERNEL
EOF
	echo " append initrd=$INITRD `echo $CMDLINE | sed 's/IP=append//g'`"
	echo "$CMDLINE" | grep -q "IP=append" && echo " ipappend 1"
  cat <<EOF
label local
 localboot 0
EOF
	exit $EXITSTATUS
fi


# Else
cat <<EOF
default local
implicit 0
allowoptions 0
timeout 0
label local
 localboot 0
EOF
exit $EXITSTATUS
